using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_Aplicacion.Modelos_MantenimientoAgrupacionesCabecera;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_HotelPuntoVenta._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_AgrupacionesClientesCabeceras_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo> g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesClientesCabeceras).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo != null) && (g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.Count() > 0))
                {
                    lst_AUX = g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_AUX;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesClientesCabeceras).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo != null) && (g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.Count() > 0))
                {
                    dnm_AUX = g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_AUX;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                string str_SQL =
                      " SELECT " +
                          nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.id) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.id) + "," +
                          nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.codigo) + "," +
                          nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.descripcion) + "," +
                          nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.sinRepeticion) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.sinRepeticion) +
                       " FROM " + nameof(HPV_AgrupacionesClientesCabeceras) +
                       " WHERE " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) + " IS null AND " +
                            " ( " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.idEmpresa) + "=@idEmpresa" +
                                (
                                    (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0)
                                        ? (" OR " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                            (_lng_id > -1 ? nameof(HPV_AgrupacionesClientesCabeceras) + "." + (nameof(HPV_AgrupacionesClientesCabeceras.id) + "=@id") : "1 = 1");

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo g_mdl_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesClientesCabeceras).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo_F3 != null)
                {
                    dnm_AUX = g_mdl_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_AUX;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_AUX = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(HPV_AgrupacionesClientesCabeceras).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo_F3 != null)
                {
                    dnm_AUX = g_mdl_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_AUX;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
               " SELECT distinct " +
                   nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.id) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.id) + "," +
                   nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.codigo) + "," +
                   nameof(INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.descripcion) +
               " FROM " + nameof(HPV_AgrupacionesClientesCabeceras) +
               " WHERE " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) + " IS NULL AND " +
                    (
                        (_lng_id > -1)
                            ? (nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.id) + " = " + _lng_id)
                            : (
                                //Filtrar por Codigo
                                (_str_CampoBusqueda.Equals(nameof(HPV_AgrupacionesClientesCabeceras.codigo)))
                                    ? (nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.codigo) + "=@Filtro")
                                    //Filtrar por Descripcion
                                    : (nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.descripcion) + "=@Filtro")
                            )
                    );


                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_HPV_AgrupacionesClientesCabeceras_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT distinct " +
                     nameof(INTERNO_MantenimientoAgrupacionesCabecera_Modelo.id) + " = " + nameof(HPV_AgrupacionesClientesCabeceras.id) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesCabecera_Modelo.codigo) + " = " + nameof(HPV_AgrupacionesClientesCabeceras.codigo) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesCabecera_Modelo.descripcion) + " = " + nameof(HPV_AgrupacionesClientesCabeceras.descripcion) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesCabecera_Modelo.sinRepeticiones) + " = " + nameof(HPV_AgrupacionesClientesCabeceras.sinRepeticion) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesCabecera_Modelo.fechaBorrado) + " = " + nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) + "," +
                     nameof(INTERNO_MantenimientoAgrupacionesCabecera_Modelo.idEmpresa) + " = " + nameof(HPV_AgrupacionesClientesCabeceras.idEmpresa) +
             " FROM " + nameof(HPV_AgrupacionesClientesCabeceras) +
             " WHERE " + nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) + " IS null AND " +
                         nameof(HPV_AgrupacionesClientesCabeceras.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoAgrupacionesCabecera_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //HPV_AgrupacionesClientesLineas ##########################################################################################
                    ThreadStart obj_ThreadStart_LINEAS = new ThreadStart(Obtener_AgrupacionesClientesLineas_Modelo_Obtener);
                    Thread obj_Thread_LINEAS = new Thread(obj_ThreadStart_LINEAS);
                    obj_Thread_LINEAS.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_AgrupacionesClientesLineas_Modelo_Obtener()
        {
            try
            {
                HPV_AgrupacionesClientesLineas_Datos obj_HPV_AgrupacionesClientesLineas_Datos = new HPV_AgrupacionesClientesLineas_Datos();
                g_dnm_Modelo_Obtener.AgrupacionesLineas = obj_HPV_AgrupacionesClientesLineas_Datos.Obtener_HPV_AgrupacionesClientesLineas_PorCabecera(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private HPV_AgrupacionesClientesCabeceras g_mdl_HPV_AgrupacionesClientesCabeceras = null;
        public HPV_AgrupacionesClientesCabeceras Obtener_Modelo_Por_Id(long _lng_id,
                                                                       bool _bol_Cargar_AgrupacionClienteLineas)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(HPV_AgrupacionesClientesCabeceras) + "." + nameof(HPV_AgrupacionesClientesCabeceras.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_AgrupacionClienteLineas);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HPV_AgrupacionesClientesCabeceras;
        }
        #region Ejecutar Consulta
        private static int g_int_TotalHilos_Modelo = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                            object[] _arr_Parametros,
                                            bool _bol_Cargar_AgrupacionClienteLineas)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_HPV_AgrupacionesClientesCabeceras = obj_Exferia_Entities.Database.SqlQuery<HPV_AgrupacionesClientesCabeceras>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_mdl_HPV_AgrupacionesClientesCabeceras != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                    }

                    //MAE_AgrupacionesClientesLineas ##########################################################################################
                    if (_bol_Cargar_AgrupacionClienteLineas)
                    {
                        ThreadStart obj_ThreadStart_AGRUPACONESCLIENTESLINEAS = new ThreadStart(Obtener_AgrupacionesClientesLineas_Modelo);
                        Thread obj_Thread_AGRUPACONESCLIENTESLINEAS = new Thread(obj_ThreadStart_AGRUPACONESCLIENTESLINEAS);
                        obj_Thread_AGRUPACONESCLIENTESLINEAS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_AgrupacionesClientesLineas_Modelo()
        {
            try
            {
                HPV_AgrupacionesClientesLineas_Datos obj_HPV_AgrupacionesClientesLineas_Datos = new HPV_AgrupacionesClientesLineas_Datos();
                g_mdl_HPV_AgrupacionesClientesCabeceras.HPV_AgrupacionesClientesLineas = obj_HPV_AgrupacionesClientesLineas_Datos.Obtener_HPV_AgrupacionesClientesLineas_PorCabecera(g_dnm_Modelo_Obtener.id);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        #region Modelos Listado
        private List<HPV_AgrupacionesClientesCabeceras> g_lst_HPV_AgrupacionesClientesCabeceras = null;
        public List<HPV_AgrupacionesClientesCabeceras> Obtener_ModeloListado_Por_Ids(List<long> _lst_ids)
        {
            try
            {
                if (_lst_ids != null && _lst_ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(HPV_AgrupacionesClientesCabeceras),
                                                                                                    nameof(HPV_AgrupacionesClientesCabeceras.id),
                                                                                                    G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                    _lst_ids);

                    string str_SQL = Obtener_Consulta_Modelo() +
                                        //WHERE
                                        " WHERE " + str_Filtro_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_HPV_AgrupacionesClientesCabeceras;
        }

        #region Ejercutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                     object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el listado
                g_lst_HPV_AgrupacionesClientesCabeceras = obj_Exferia_Entities.Database.SqlQuery<HPV_AgrupacionesClientesCabeceras>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(HPV_AgrupacionesClientesCabeceras.id) + " , " +
                   nameof(HPV_AgrupacionesClientesCabeceras.codigo) + " , " +
                   nameof(HPV_AgrupacionesClientesCabeceras.descripcion) + " , " +
                   nameof(HPV_AgrupacionesClientesCabeceras.sinRepeticion) + " , " +
                   nameof(HPV_AgrupacionesClientesCabeceras.idEmpresa) + " , " +
                   nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) +
               " FROM " + nameof(HPV_AgrupacionesClientesCabeceras);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoAgrupacionesCabecera_Modelo mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo_AGrabar = (INTERNO_MantenimientoAgrupacionesCabecera_Modelo)_mdl_obj;
                HPV_AgrupacionesClientesCabeceras mdl_HPV_AgrupacionesClientesCabeceras_DatosViejos = new HPV_AgrupacionesClientesCabeceras();

                // Ver si existe ######################################################################
                HPV_AgrupacionesClientesCabeceras mdl_HPV_AgrupacionesClientesCabeceras_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo_AGrabar.id, false);
                //######################################################################################

                //UPDATE
                if (mdl_HPV_AgrupacionesClientesCabeceras_Final != null)
                { 
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HPV_AgrupacionesClientesCabeceras_Final, mdl_HPV_AgrupacionesClientesCabeceras_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_AgrupacionesClientesCabeceras_Final, mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo_AGrabar);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_AgrupacionesClientesCabeceras) +
                                         " SET " +
                                             nameof(HPV_AgrupacionesClientesCabeceras.codigo) + "=@codigo," +
                                             nameof(HPV_AgrupacionesClientesCabeceras.descripcion) + "=@descripcion," +
                                             nameof(HPV_AgrupacionesClientesCabeceras.sinRepeticion) + "=@sinRepeticion," +
                                             nameof(HPV_AgrupacionesClientesCabeceras.idEmpresa) + "=@idEmpresa," +
                                             nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) + "=@fechaBorrado " +
                                         " WHERE " +
                                             nameof(HPV_AgrupacionesClientesCabeceras.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_HPV_AgrupacionesClientesCabeceras_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_HPV_AgrupacionesClientesCabeceras_Final.descripcion),
                        new SqlParameter("@sinRepeticion",  mdl_HPV_AgrupacionesClientesCabeceras_Final.sinRepeticion),
                        new SqlParameter("@idEmpresa",  mdl_HPV_AgrupacionesClientesCabeceras_Final.idEmpresa),
                        mdl_HPV_AgrupacionesClientesCabeceras_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_AgrupacionesClientesCabeceras_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_HPV_AgrupacionesClientesCabeceras_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo_AGrabar.id;
                }
                //INSERT
                else
                {
                    mdl_HPV_AgrupacionesClientesCabeceras_Final = new HPV_AgrupacionesClientesCabeceras();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_HPV_AgrupacionesClientesCabeceras_Final, mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HPV_AgrupacionesClientesCabeceras) +
                                               " (" +
                                                       nameof(HPV_AgrupacionesClientesCabeceras.codigo) + "," +
                                                       nameof(HPV_AgrupacionesClientesCabeceras.descripcion) + "," +
                                                       nameof(HPV_AgrupacionesClientesCabeceras.sinRepeticion) + "," +
                                                       nameof(HPV_AgrupacionesClientesCabeceras.idEmpresa) + "," +
                                                       nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(HPV_AgrupacionesClientesCabeceras.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@sinRepeticion," +
                                                   "@idEmpresa," +
                                                   "@fechaBorrado" +
                                               " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_HPV_AgrupacionesClientesCabeceras_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_HPV_AgrupacionesClientesCabeceras_Final.descripcion),
                        new SqlParameter("@sinRepeticion",  mdl_HPV_AgrupacionesClientesCabeceras_Final.sinRepeticion),
                        new SqlParameter("@idEmpresa",  mdl_HPV_AgrupacionesClientesCabeceras_Final.idEmpresa),
                        mdl_HPV_AgrupacionesClientesCabeceras_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_HPV_AgrupacionesClientesCabeceras_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_AgrupacionesClientesCabeceras), mdl_HPV_AgrupacionesClientesCabeceras_DatosViejos, mdl_HPV_AgrupacionesClientesCabeceras_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        private void Cargar_DatosModelo(HPV_AgrupacionesClientesCabeceras _mdl_HPV_AgrupacionesClientesCabeceras, INTERNO_MantenimientoAgrupacionesCabecera_Modelo _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo)
        {
            // Cargar los Datos Nuevos del Modelo
            _mdl_HPV_AgrupacionesClientesCabeceras.id = _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo.id;
            _mdl_HPV_AgrupacionesClientesCabeceras.codigo = _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo.codigo;
            _mdl_HPV_AgrupacionesClientesCabeceras.descripcion = _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo.descripcion;
            _mdl_HPV_AgrupacionesClientesCabeceras.idEmpresa = _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo.idEmpresa;
            _mdl_HPV_AgrupacionesClientesCabeceras.fechaBorrado = _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo.fechaBorrado;
            _mdl_HPV_AgrupacionesClientesCabeceras.sinRepeticion = _mdl_INTERNO_MantenimientoAgrupacionesCabecera_Modelo.sinRepeticiones;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HPV_AgrupacionesClientesCabeceras mdl_HPV_AgrupacionesClientesCabeceras_Final = Obtener_Modelo_Por_Id(_lng_id, false);
                //######################################################################################

                if (mdl_HPV_AgrupacionesClientesCabeceras_Final != null)
                {

                    DateTime dtt_FechaActual = DateTime.Now;

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(HPV_AgrupacionesClientesCabeceras) +
                                                " SET " +
                                                nameof(HPV_AgrupacionesClientesCabeceras.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(HPV_AgrupacionesClientesCabeceras.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  dtt_FechaActual),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Actualizar la fechaBorrado en Lineas
                    #region UPDATE LINEAS
                    string str_SQL_Update_Lineas = " UPDATE " + nameof(MAE_AgrupacionesClientesLineas) +
                                                " SET " +
                                                nameof(MAE_AgrupacionesClientesLineas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_AgrupacionesClientesLineas.idAgrupacionClienteCabecera) + "=@idAgrupacionClienteCabecera";
                    //Parametros
                    object[] arr_Parametros_Update_Lineas = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  dtt_FechaActual),
                        new SqlParameter("@idAgrupacionClienteCabecera", _lng_id)
                    };
                    #endregion

                    //Update Lineas
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update_Lineas, arr_Parametros_Update_Lineas);

                    //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(HPV_AgrupacionesClientesCabeceras), null, mdl_HPV_AgrupacionesClientesCabeceras_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }
                    
                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_AgrupacionesClientesCabeceras_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
